unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, VKDBFDataSet, Grids, DBGrids, StdCtrls, DBCtrls, ExtDlgs, ExtCtrls,
  {$IFDEF VER140} Variants, {$ENDIF}
  VKDBFPrx, ActiveX, ComObj, axctrls;

type
  TForm1 = class(TForm)
    vkdbfntx: TVKDBFNTX;
    DataSource1: TDataSource;
    OpenPictureDialog1: TOpenPictureDialog;
    GroupBox1: TGroupBox;
    VKNestedDBF1: TVKNestedDBF;
    vkdbfntxF1: TStringField;
    vkdbfntxF2: TLargeintField;
    vkdbfntxM1: TMemoField;
    vkdbfntxB1: TBlobField;
    vkdbfntxDS1: TDataSetField;
    DataSource2: TDataSource;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    Splitter1: TSplitter;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    DBMemo1: TDBMemo;
    Splitter2: TSplitter;
    GroupBox3: TGroupBox;
    Splitter3: TSplitter;
    GroupBox4: TGroupBox;
    DBImage1: TDBImage;
    Button1: TButton;
    DBGrid2: TDBGrid;
    DBMemo2: TDBMemo;
    Panel3: TPanel;
    RadioButton1: TRadioButton;
    Edit1: TEdit;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    GroupBox5: TGroupBox;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    dbfType: TComboBox;
    Label1: TLabel;
    LobBlockSize: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }

    stgOpen: IStorage;
    stm1: IStream;
    stm2: IStream;
    stm3: IStream;

    DBFStream: TStream;
    DBTStream: TStream;
    NTXStream: TStream;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then begin
    VKDBFNTX.Edit;
    DBImage1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
    VKDBFNTX.Post;
  end;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  Edit1.Enabled := RadioButton1.Checked;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
  GroupBox5.Enabled := RadioButton3.Checked;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  q: array[0..20] of WideChar;
begin
  vkdbfntx.Active := False;
  vkdbfntx.Indexes.Clear;

  if (dbfType.Text = '') or (dbfType.Text = 'xClipper') or (dbfType.Text = 'xBaseIII') then vkdbfntx.DbfVersion := xBaseIII;
  if dbfType.Text = 'xBaseIV' then vkdbfntx.DbfVersion := xBaseIV;
  if dbfType.Text = 'xBaseV' then vkdbfntx.DbfVersion := xBaseV;
  if dbfType.Text = 'xBaseVII' then vkdbfntx.DbfVersion := xBaseVII;
  if dbfType.Text = 'xFoxPro' then vkdbfntx.DbfVersion := xFoxPro;
  if dbfType.Text = 'xVisualFoxPro' then vkdbfntx.DbfVersion := xVisualFoxPro;
  vkdbfntx.LobBlockSize := StrToInt(LobBlockSize.Text);

  if RadioButton1.Checked then begin
    vkdbfntx.StorageType := pstFile;
    vkdbfntx.DBFFileName := Edit1.Text;
    vkdbfntx.DBFIndexDefs[0].StorageType := pstFile;
    vkdbfntx.DBFIndexDefs[0].IndexFileName := ChangeFileExt(Edit1.Text, '.NTX');
    if not CheckBox1.Checked then vkdbfntx.CreateTable;
    vkdbfntx.Active := True;
  end;
  if RadioButton2.Checked then begin
    vkdbfntx.StorageType := pstInnerStream;
    vkdbfntx.DBFIndexDefs[0].StorageType := pstInnerStream;
    vkdbfntx.CreateTable;
    vkdbfntx.Active := True;
  end;
  if RadioButton3.Checked then begin
    if RadioButton4.Checked then begin

      if DBFStream <> nil then begin
        DBFStream.Free;
        DBTStream.Free;
        NTXStream.Free;
        DBFStream := nil;
        DBTStream := nil;
        NTXStream := nil;
      end;
      DBFStream := TFileStream.Create(Edit2.Text, fmCreate);
      DBTStream := TFileStream.Create(ChangeFileExt(Edit2.Text, '.DBT'), fmCreate);
      NTXStream := TFileStream.Create(ChangeFileExt(Edit2.Text, '.NTX'), fmCreate);

      vkdbfntx.StorageType := pstOuterStream;
      vkdbfntx.OuterStream := DBFStream;
      vkdbfntx.OuterLobStream := DBTStream;

      vkdbfntx.DBFIndexDefs[0].StorageType := pstOuterStream;
      vkdbfntx.DBFIndexDefs[0].OuterStream := NTXStream;

      if not CheckBox1.Checked then vkdbfntx.CreateTable;

      vkdbfntx.Active := True;

    end;
    if RadioButton5.Checked then begin


      if DBFStream <> nil then begin
        DBFStream.Free;
        DBTStream.Free;
        NTXStream.Free;
        DBFStream := nil;
        DBTStream := nil;
        NTXStream := nil;
        stm1 := nil;
        stm2 := nil;
        stm3 := nil;
        stgOpen := nil;
      end;

      stgOpen := nil;
      StringToWideChar(Edit3.Text, q, 21);

      if not CheckBox1.Checked then begin

        OleCheck(StgCreateDocfile( q,
                        STGM_CREATE or STGM_READWRITE or STGM_SHARE_DENY_NONE or STGM_TRANSACTED,
                        0, stgOpen));

        OleCheck(stgOpen.CreateStream(
          'Test.dbf',
          STGM_CREATE or STGM_READWRITE or STGM_SHARE_EXCLUSIVE or STGM_DIRECT,
          0, 0, stm1));
        DBFStream := TOleStream.Create(stm1);

        OleCheck(stgOpen.CreateStream(
          'Test.dbt',
          STGM_CREATE or STGM_READWRITE or STGM_SHARE_EXCLUSIVE or STGM_DIRECT,
          0, 0, stm2));
        DBTStream := TOleStream.Create(stm2);

        OleCheck(stgOpen.CreateStream(
          'Test.ntx',
          STGM_CREATE or STGM_READWRITE or STGM_SHARE_EXCLUSIVE or STGM_DIRECT,
          0, 0, stm3));
        NTXStream := TOleStream.Create(stm3);

      end else begin

        OleCheck(StgOpenStorage( q,
                        nil,
                        STGM_READWRITE or STGM_SHARE_DENY_NONE or STGM_TRANSACTED,
                        nil,
                        0,
                        stgOpen));

        OleCheck(stgOpen.OpenStream(
          'Test.dbf',
          nil,
          STGM_READWRITE or STGM_SHARE_EXCLUSIVE or STGM_DIRECT,
          0, stm1));
        DBFStream := TOleStream.Create(stm1);

        OleCheck(stgOpen.OpenStream(
          'Test.dbt',
          nil,
          STGM_READWRITE or STGM_SHARE_EXCLUSIVE or STGM_DIRECT,
          0, stm2));
        DBTStream := TOleStream.Create(stm2);

        OleCheck(stgOpen.OpenStream(
          'Test.ntx',
          nil,
          STGM_READWRITE or STGM_SHARE_EXCLUSIVE or STGM_DIRECT,
          0, stm3));
        NTXStream := TOleStream.Create(stm3);

      end;

      vkdbfntx.StorageType := pstOuterStream;
      vkdbfntx.OuterStream := DBFStream;
      vkdbfntx.OuterLobStream := DBTStream;

      vkdbfntx.DBFIndexDefs[0].StorageType := pstOuterStream;
      vkdbfntx.DBFIndexDefs[0].OuterStream := NTXStream;

      if not CheckBox1.Checked then vkdbfntx.CreateTable;

      vkdbfntx.Active := True;

    end;
  end;
  if vkdbfntx.Active then vkdbfntx.Orders[0].Active := True;

  case vkdbfntx.DbfVersion of
      xClipper:       dbfType.Text := 'xClipper';
      xBaseIII:       dbfType.Text := 'xBaseIII';
      xBaseIV:        dbfType.Text := 'xBaseIV';
      xBaseV:         dbfType.Text := 'xBaseV';
      xBaseVII:       dbfType.Text := 'xBaseVII';
      xFoxPro:        dbfType.Text := 'xFoxPro';
      xVisualFoxPro:  dbfType.Text := 'xVisualFoxPro';
  end;
  LobBlockSize.Text := IntToStr(vkdbfntx.LobBlockSize);

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if stgOpen <> nil then OleCheck(stgOpen.Commit(STGC_DEFAULT));
  //if stgOpen <> nil then OleCheck(stgOpen.Commit(STGC_ONLYIFCURRENT));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  vkdbfntx.Refresh;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  vkdbfntx.Active := False;
  vkdbfntx.Active := True;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if stgOpen <> nil then begin
    vkdbfntx.Active := False;
    OleCheck(stgOpen.Revert);
  end;
end;

end.
